﻿using Microsoft.AspNetCore.Mvc;
using System.Linq;
using System.Collections;
using System.Collections.Generic;
using System.Linq.Dynamic.Core;
using System;
using System.Reflection;
using Syncfusion.JavaScript;
using Syncfusion.JavaScript.DataSources;
using Microsoft.EntityFrameworkCore;
using Schedule.Models;
using Syncfusion.JavaScript.Models;
using Newtonsoft.Json;
using Microsoft.AspNetCore.Http;
using System.Data.SqlClient;

namespace Schedule.Controllers
{
    public class HomeController : Controller
    {
        private NORTHWNDContext _context;
        public static List<Order> orddata = new List<Order>();
        public HomeController(NORTHWNDContext context)
        {
            _context = context;
        }
       
        public IActionResult Index()
        {
            if (orddata.Count() == 0)
                BindData();
            return View();
        }

        public void BindData()
        {
            int code = 10000;
            for (int i = 1; i < 10; i++)
            {
                orddata.Add(new Order(code + 1, "ALFKI", i + 0, 2.3 * i, new DateTime(1991, 05, 15), "Berlin"));
                orddata.Add(new Order(code + 2, "ANATR", i + 2, 3.3 * i, new DateTime(1990, 04, 04), "Madrid"));
                orddata.Add(new Order(code + 3, "ANTON", i + 1, 4.3 * i, new DateTime(1957, 11, 30), "Cholchester"));
                orddata.Add(new Order(code + 4, "BLONP", i + 3, 5.3 * i, new DateTime(1930, 10, 22), "Marseille"));
                orddata.Add(new Order(code + 5, "BOLID", i + 4, 6.3 * i, new DateTime(1953, 02, 18), "Tsawassen"));
                code += 5;
            }
        }

        public ActionResult DataSource([FromBody]DataManager dm)
        {
            IEnumerable data = orddata;
            DataOperations operation = new DataOperations();
            if (dm.Sorted != null && dm.Sorted.Count > 0) //Sorting
            {
                data = operation.PerformSorting(data, dm.Sorted);
            }
            if (dm.Where != null && dm.Where.Count > 0) //Filtering
            {
                data = operation.PerformWhereFilter(data, dm.Where, dm.Where[0].Operator);
            }
            int count = data.Cast<Order>().Count();
            if (dm.Skip != 0)
            {
                data = operation.PerformSkip(data, dm.Skip);
            }
            if (dm.Take != 0)
            {
                data = operation.PerformTake(data, dm.Take);
            }
            return Json(new { result = data, count = count });

        }
        public ActionResult NormalUpdate([FromBody]CRUDModel<Order> myObject)
        {
            var ord = myObject.Value;
            Order val = orddata.Where(or => or.OrderID == ord.OrderID).FirstOrDefault();
            val.OrderID = ord.OrderID;
            val.EmployeeID = ord.EmployeeID;
            val.CustomerID = ord.CustomerID;
            val.Freight = ord.Freight;
            val.ShipCity = ord.ShipCity;
            if(myObject.Value.EmployeeID > 9)
            throw new Exception("EmployeeID must be above 1000");
            return Json(myObject.Value);
        }
        public ActionResult NormalInsert([FromBody]CRUDModel<Order> value)
        {
            if (value.Value.OrderID > 10000)
                throw new Exception("OrderID must be above 1000");
            orddata.Insert(orddata.Count, value.Value);
            return Json(orddata);
        }
        public ActionResult NormalDelete([FromBody]CRUDModel<Order> value)
        {
            orddata.Remove(orddata.Where(or => or.OrderID == int.Parse(value.Key.ToString())).FirstOrDefault());
            return Json(value);
        }
        public class Order
        {
            public Order()
            {

            }
            public Order(long OrderId, string CustomerId, int EmployeeId, double Freight, DateTime OrderDate, string ShipCity)
            {
                this.OrderID = OrderId;
                this.CustomerID = CustomerId;
                this.EmployeeID = EmployeeId;
                this.Freight = Freight;
                this.OrderDate = OrderDate;
                this.ShipCity = ShipCity;
            }


            public long? OrderID { get; set; }

            public string CustomerID { get; set; }

            public int? EmployeeID { get; set; }
            public double? Freight { get; set; }
            public DateTime OrderDate { get; set; }
            public string ShipCity { get; set; }
        }
     }
}
